Index: /trunk/sources/HeuristicLab.Services.Hive/3.3/HiveService.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.Hive/3.3/HiveService.cs	(revision 12877)
+++ /trunk/sources/HeuristicLab.Services.Hive/3.3/HiveService.cs	(revision 12878)
@@ -23,13 +23,15 @@
 using System.Collections.Generic;
 using System.Linq;
+using System.Security;
 using System.ServiceModel;
+using HeuristicLab.Services.Access;
+using HeuristicLab.Services.Hive.DataAccess.Interfaces;
 using HeuristicLab.Services.Hive.DataTransfer;
+using HeuristicLab.Services.Hive.Manager;
 using HeuristicLab.Services.Hive.ServiceContracts;
 using DA = HeuristicLab.Services.Hive.DataAccess;
 using DT = HeuristicLab.Services.Hive.DataTransfer;
 
-
 namespace HeuristicLab.Services.Hive {
-
   /// <summary>
   /// Implementation of the Hive service (interface <see cref="IHiveService"/>).
@@ -39,197 +41,192 @@
   [HiveOperationContextBehavior]
   public class HiveService : IHiveService {
-    private IHiveDao dao {
-      get { return ServiceLocator.Instance.HiveDao; }
-    }
-    private IOptimizedHiveDao optimizedDao {
-      get { return ServiceLocator.Instance.OptimizedHiveDao; }
-    }
-    private Access.IRoleVerifier authen {
+    private static readonly DA.TaskState[] CompletedStates = { DA.TaskState.Finished, DA.TaskState.Aborted, DA.TaskState.Failed };
+
+    private IPersistenceManager PersistenceManager {
+      get { return ServiceLocator.Instance.PersistenceManager; }
+    }
+
+    private IUserManager UserManager {
+      get { return ServiceLocator.Instance.UserManager; }
+    }
+
+    private IRoleVerifier RoleVerifier {
       get { return ServiceLocator.Instance.RoleVerifier; }
     }
-    private IAuthorizationManager author {
+
+    private IAuthorizationManager AuthorizationManager {
       get { return ServiceLocator.Instance.AuthorizationManager; }
     }
-    private DataAccess.ITransactionManager trans {
-      get { return ServiceLocator.Instance.TransactionManager; }
-    }
-    private IEventManager eventManager {
+    private IEventManager EventManager {
       get { return ServiceLocator.Instance.EventManager; }
     }
-    private Access.IUserManager userManager {
-      get { return ServiceLocator.Instance.UserManager; }
-    }
-    private HeartbeatManager heartbeatManager {
+    private HeartbeatManager HeartbeatManager {
       get { return ServiceLocator.Instance.HeartbeatManager; }
     }
 
     #region Task Methods
-    public Guid AddTask(Task task, TaskData taskData, IEnumerable<Guid> resourceIds) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
-      return trans.UseTransaction(() => {
-        var t = DT.Convert.ToEntity(task);
-        t.RequiredPlugins.AddRange(task.PluginsNeededIds.Select(pluginId => new DA.RequiredPlugin { Task = t, PluginId = pluginId }));
-
-        t.JobData = DT.Convert.ToEntity(taskData);
-        t.JobData.LastUpdate = DateTime.Now;
-
-        optimizedDao.AddTask(t);
-
-        dao.AssignJobToResource(t.TaskId, resourceIds);
-
-        optimizedDao.UpdateTaskState(t.TaskId, DA.TaskState.Waiting, null, userManager.CurrentUserId, null);
-
-        return t.TaskId;
-      }, false, true);
-    }
-
-    public Guid AddChildTask(Guid parentTaskId, Task task, TaskData taskData) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+    public Guid AddTask(DT.Task task, DT.TaskData taskData, IEnumerable<Guid> resourceIds) {
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      var pm = PersistenceManager;
+      using (new PerformanceLogger("AddTask")) {
+        var taskDao = pm.TaskDao;
+        var stateLogDao = pm.StateLogDao;
+        var newTask = task.ToEntity();
+        newTask.JobData = taskData.ToEntity();
+        newTask.JobData.LastUpdate = DateTime.Now;
+        newTask.AssignedResources.AddRange(resourceIds.Select(
+          x => new DA.AssignedResource {
+            ResourceId = x
+          }));
+        newTask.State = DA.TaskState.Waiting;
+        return pm.UseTransaction(() => {
+          taskDao.Save(newTask);
+          pm.SubmitChanges();
+          stateLogDao.Save(new DA.StateLog {
+            State = DA.TaskState.Waiting,
+            DateTime = DateTime.Now,
+            TaskId = newTask.TaskId,
+            UserId = UserManager.CurrentUserId,
+            SlaveId = null,
+            Exception = null
+          });
+          pm.SubmitChanges();
+          return newTask.TaskId;
+        }, false, true);
+      }
+    }
+
+    public Guid AddChildTask(Guid parentTaskId, DT.Task task, DT.TaskData taskData) {
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      IEnumerable<Guid> resourceIds;
+      var pm = PersistenceManager;
+      using (new PerformanceLogger("AddChildTask")) {
+        var assignedResourceDao = pm.AssignedResourceDao;
+        resourceIds = pm.UseTransaction(() => {
+          return assignedResourceDao.GetByTaskId(parentTaskId)
+            .Select(x => x.ResourceId)
+            .ToList();
+        });
+      }
       task.ParentTaskId = parentTaskId;
-      return AddTask(task, taskData, optimizedDao.GetAssignedResourceIds(parentTaskId).ToList());
-    }
-
-    public Task GetTask(Guid taskId) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
-      author.AuthorizeForTask(taskId, Permission.Read);
-
-      return trans.UseTransaction(() => {
-        return DT.Convert.ToDto(optimizedDao.GetTaskById(taskId));
-      }, false, false);
-    }
-
-    public IEnumerable<Task> GetTasks() {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
-      return trans.UseTransaction(() => {
-        var tasks = dao.GetTasks(x => true);
-        foreach (var task in tasks)
-          author.AuthorizeForTask(task.Id, Permission.Read);
-        return tasks;
-      });
-    }
-
-    public IEnumerable<LightweightTask> GetLightweightTasks(IEnumerable<Guid> taskIds) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
-
-      return trans.UseTransaction(() => {
-        var tasks = dao.GetTasks(x => taskIds.Contains(x.TaskId)).Select(x => new LightweightTask(x)).ToArray();
-        foreach (var task in tasks)
-          author.AuthorizeForTask(task.Id, Permission.Read);
-        return tasks;
-      }, false, false);
-    }
-
-    public IEnumerable<LightweightTask> GetLightweightChildTasks(Guid? parentTaskId, bool recursive, bool includeParent) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
-
-      return trans.UseTransaction(() => {
-        var tasks = GetChildTasks(parentTaskId, recursive, includeParent).Select(x => new LightweightTask(x)).ToArray();
-        foreach (var task in tasks)
-          author.AuthorizeForTask(task.Id, Permission.Read);
-        return tasks;
-      }, false, false);
-    }
-
-    public IEnumerable<LightweightTask> GetLightweightJobTasks(Guid jobId) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
-      author.AuthorizeForJob(jobId, Permission.Read);
-
-      return trans.UseTransaction(() => {
-        return optimizedDao.GetLightweightTasks(jobId).ToArray();
-      }, false, true);
-    }
-
-    public IEnumerable<LightweightTask> GetLightweightJobTasksWithoutStateLog(Guid jobId) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
-      author.AuthorizeForJob(jobId, Permission.Read);
-
-      return trans.UseTransaction(() => {
-        return dao.GetLightweightTasksWithoutStateLog(task => task.JobId == jobId).ToArray();
-      }, false, false);
-    }
-
-    public TaskData GetTaskData(Guid taskId) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
-      author.AuthorizeForTask(taskId, Permission.Read);
-
-      return trans.UseTransaction(() => {
-        return dao.GetTaskData(taskId);
-      });
-    }
-
-    public void UpdateTask(Task taskDto) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
-      author.AuthorizeForTask(taskDto.Id, Permission.Full);
-
-      trans.UseTransaction(() => {
-        var task = optimizedDao.GetTaskByDto(taskDto);
-        optimizedDao.UpdateTask(task);
-      });
-    }
-
-    public void UpdateTaskData(Task task, TaskData taskData) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
-      author.AuthorizeForTask(task.Id, Permission.Full);
-
-      trans.UseTransaction(() => {
-        var t = optimizedDao.GetTaskByDto(task);
-        optimizedDao.UpdateTask(t);
-      });
-
-      trans.UseTransaction(() => {
-        var data = optimizedDao.GetTaskDataByDto(taskData);
-        data.LastUpdate = DateTime.Now;
-        optimizedDao.UpdateTaskData(data);
-      });
-    }
-
-    public void DeleteTask(Guid taskId) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
-      author.AuthorizeForTask(taskId, Permission.Full);
-      trans.UseTransaction(() => {
-        dao.DeleteTask(taskId);
-      });
-    }
-
-    public void DeleteChildTasks(Guid parentTaskId) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
-      author.AuthorizeForTask(parentTaskId, Permission.Full);
-      trans.UseTransaction(() => {
-        var tasks = GetChildTasks(parentTaskId, true, false);
-        foreach (var task in tasks) {
-          dao.DeleteTask(task.Id);
-          dao.DeleteTaskData(task.Id);
-        };
-      });
-    }
-
-    public Task UpdateTaskState(Guid taskId, TaskState taskState, Guid? slaveId, Guid? userId, string exception) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
-      author.AuthorizeForTask(taskId, Permission.Full);
-
-      return trans.UseTransaction(() => {
-        var task = optimizedDao.UpdateTaskState(taskId, DT.Convert.ToEntity(taskState), slaveId, userId, exception);
-
-        if (task.Command.HasValue && task.Command.Value == DA.Command.Pause && task.State == DA.TaskState.Paused) {
-          task.Command = null;
-        } else if (task.Command.HasValue && task.Command.Value == DA.Command.Abort && task.State == DA.TaskState.Aborted) {
-          task.Command = null;
-        } else if (task.Command.HasValue && task.Command.Value == DA.Command.Stop && task.State == DA.TaskState.Aborted) {
-          task.Command = null;
-        } else if (taskState == TaskState.Paused && !task.Command.HasValue) {
-          // slave paused and uploaded the task (no user-command) -> set waiting.
-          task = optimizedDao.UpdateTaskState(taskId, DA.TaskState.Waiting, slaveId, userId, exception);
-        }
-
-        return DT.Convert.ToDto(task);
-      });
-    }
-
-    public IEnumerable<Task> GetTasksByResourceId(Guid resourceId) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator);
-      var tasks = trans.UseTransaction(() => dao.GetJobsByResourceId(resourceId));
-      foreach (var task in tasks)
-        author.AuthorizeForTask(task.Id, Permission.Read);
-      return tasks;
+      return AddTask(task, taskData, resourceIds);
+    }
+
+    public DT.Task GetTask(Guid taskId) {
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
+      AuthorizationManager.AuthorizeForTask(taskId, Permission.Read);
+      var pm = PersistenceManager;
+      using (new PerformanceLogger("GetTask")) {
+        var taskDao = pm.TaskDao;
+        return pm.UseTransaction(() => {
+          var task = taskDao.GetById(taskId);
+          return task.ToDto();
+        });
+      }
+    }
+
+    public IEnumerable<DT.LightweightTask> GetLightweightJobTasks(Guid jobId) {
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      AuthorizationManager.AuthorizeForJob(jobId, Permission.Read);
+      var pm = PersistenceManager;
+      using (new PerformanceLogger("GetLightweightJobTasks")) {
+        var taskDao = pm.TaskDao;
+        return pm.UseTransaction(() => {
+          return taskDao.GetByJobId(jobId)
+            .ToList()
+            .Select(x => new DT.LightweightTask {
+              Id = x.TaskId,
+              ExecutionTime = TimeSpan.FromMilliseconds(x.ExecutionTimeMs),
+              ParentTaskId = x.ParentTaskId,
+              StateLog = x.StateLogs.OrderBy(y => y.DateTime)
+                                    .Select(z => z.ToDto())
+                                    .ToList(),
+              State = x.State.ToDto(),
+              Command = x.Command.ToDto(),
+              LastTaskDataUpdate = x.JobData.LastUpdate
+            })
+            .ToList();
+        }, false, true);
+      }
+    }
+
+    public IEnumerable<DT.LightweightTask> GetLightweightJobTasksWithoutStateLog(Guid jobId) {
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      AuthorizationManager.AuthorizeForJob(jobId, Permission.Read);
+      var pm = PersistenceManager;
+      using (new PerformanceLogger("GetLightweightJobTasksWithoutStateLog")) {
+        var taskDao = pm.TaskDao;
+        return pm.UseTransaction(() => {
+          return taskDao.GetByJobId(jobId)
+            .ToList()
+            .Select(x => new DT.LightweightTask {
+              Id = x.TaskId,
+              ExecutionTime = TimeSpan.FromMilliseconds(x.ExecutionTimeMs),
+              ParentTaskId = x.ParentTaskId,
+              StateLog = new List<DT.StateLog>(),
+              State = x.State.ToDto(),
+              Command = x.Command.ToDto(),
+              LastTaskDataUpdate = x.JobData.LastUpdate
+            })
+            .ToList();
+        }, false, true);
+      }
+    }
+
+    public DT.TaskData GetTaskData(Guid taskId) {
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
+      AuthorizationManager.AuthorizeForTask(taskId, Permission.Read);
+      var pm = PersistenceManager;
+      using (new PerformanceLogger("GetTaskData")) {
+        var taskDataDao = pm.TaskDataDao;
+        return pm.UseTransaction(() => taskDataDao.GetById(taskId).ToDto());
+      }
+    }
+
+    public void UpdateTask(DT.Task taskDto) {
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
+      AuthorizationManager.AuthorizeForTask(taskDto.Id, Permission.Full);
+      var pm = PersistenceManager;
+      using (new PerformanceLogger("UpdateTask")) {
+        var taskDao = pm.TaskDao;
+        pm.UseTransaction(() => {
+          var task = taskDao.GetById(taskDto.Id);
+          taskDto.CopyToEntity(task);
+          pm.SubmitChanges();
+        });
+      }
+    }
+
+    public void UpdateTaskData(DT.Task taskDto, DT.TaskData taskDataDto) {
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
+      AuthorizationManager.AuthorizeForTask(taskDto.Id, Permission.Full);
+      var pm = PersistenceManager;
+      using (new PerformanceLogger("UpdateTaskData")) {
+        var taskDao = pm.TaskDao;
+        var taskDataDao = pm.TaskDataDao;
+        pm.UseTransaction(() => {
+          var task = taskDao.GetById(taskDto.Id);
+          var taskData = taskDataDao.GetById(taskDataDto.TaskId);
+          taskDto.CopyToEntity(task);
+          taskDataDto.CopyToEntity(taskData);
+          taskData.LastUpdate = DateTime.Now;
+          pm.SubmitChanges();
+        });
+      }
+    }
+
+    public DT.Task UpdateTaskState(Guid taskId, DT.TaskState taskState, Guid? slaveId, Guid? userId, string exception) {
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
+      AuthorizationManager.AuthorizeForTask(taskId, Permission.Full);
+      var pm = PersistenceManager;
+      using (new PerformanceLogger("UpdateTaskState")) {
+        var taskDao = pm.TaskDao;
+        return pm.UseTransaction(() => {
+          var task = taskDao.GetById(taskId);
+          UpdateTaskState(pm, task, taskState, slaveId, userId, exception);
+          pm.SubmitChanges();
+          return task.ToDto();
+        });
+      }
     }
     #endregion
